#include <bx.h>



#define PI 3.14159265358979


int main (void)
{
  bx_window window;
  int w= 300, h= 300;
  double x1= w/2;
  double y1= h/2;
  double r1= 0.75*w / 2;
  double r2= r1/2.5;
  double angle;
  bx_init ();
  window= bx_create_window ("hypocycloid", 10, 10, w, h);
    
  for (angle= 0; /**/; angle+= 0.5) {
    double dr= r1-r2, q= dr/r2;
    double alpha= angle * PI / 180.0;
    double beta= - q * alpha;
    double x2= x1 + dr * cos (alpha);
    double y2= y1 - dr * sin (alpha);
    double x3= x2 + r2 * cos (beta);
    double y3= y2 - r2 * sin (beta);
    if (alpha > 360) alpha -= 360;
    bx_clear_canvas (window, bx_pale_yellow ());
    
    bx_set_color (bx_red ());
    bx_draw_circle (window, x1 -  1, y1 -  1,    3,    3, BX_FILLED);
    bx_draw_circle (window, x1 - r1, y1 - r1, 2*r1, 2*r1, BX_NOT_FILLED);
    bx_set_color (bx_blue ());
    bx_draw_circle (window, x2 - r2, y2 - r2, 2*r2, 2*r2, BX_NOT_FILLED);
    bx_draw_circle (window, x2 -  1, y2 -  1,    3,    3, BX_FILLED);
    
    bx_set_color (bx_black ());
    bx_draw_circle (window, x3 -  1, y3 -  1,    3,    3, BX_FILLED);
    bx_show_canvas (window, 10);
    
  }
  return 0;
}
