
#include <bx.h>

#define NB_GHOSTS 10

int main (void)
{
  bx_window window;
  unsigned w= 500, h= 500;
  int current= 0, k, x[NB_GHOSTS], y[NB_GHOSTS];
  bx_mouse mouse;

  bx_init ();

  window= bx_create_window ("mouse driven ghost cross", 10, 10, w, h);
  mouse= bx_read_mouse (window);
  for (k= 0; k < NB_GHOSTS; k++) {
    x[k]= bx_mouse_x (mouse);
    y[k]= bx_mouse_y (mouse);
  }

  for (;;) {
    current= (current + 1) % NB_GHOSTS;
    mouse= bx_read_mouse (window);
    x [current]= bx_mouse_x (mouse);
    y [current]= bx_mouse_y (mouse);
    
    bx_clear_canvas (window, bx_pale_yellow ());
    bx_set_line_width (3);
    
    for (k= 0; k < NB_GHOSTS; k++) {
      int ghost= (current + k + 1) % NB_GHOSTS;
      double progress= k / (double) NB_GHOSTS;
      bx_color color= bx_blend_color (bx_pale_yellow (), 
                                      progress, 
                                      bx_dark_red ());
      bx_set_color (color);
      
      bx_draw_circle (window, x[ghost]-20, y[ghost]-20, 40, 40, 0);
      bx_draw_line   (window, x[ghost]-30, y[ghost] ,x[ghost]+30, y[ghost]);
      bx_draw_line   (window, x[ghost], y[ghost]-30 ,x[ghost], y[ghost]+30);
    }

    bx_show_canvas (window, 30);

  }
  return 0;
}
