

#include "bx.h"


void
draw_eye (bx_window window,
          int x_eye, int y_eye, unsigned r_eye, 
          int xm, int ym, unsigned r_spot)
{
  double dx, dy, dist;
  int x_spot, y_spot;

  bx_set_color (bx_black ());
  bx_set_line_width (3);
  bx_draw_circle (window, x_eye-r_eye, y_eye-r_eye, 2*r_eye, 2*r_eye, 0);
  
  dx= xm-x_eye; dy= ym-y_eye;  
  dist= sqrt (dx*dx + dy*dy);
  if (dist < r_eye - r_spot) {
    x_spot= xm;
    y_spot= ym;
    bx_set_color (bx_red ());
  } else {
    x_spot= x_eye + (dx/dist) * (r_eye - r_spot);
    y_spot= y_eye + (dy/dist) * (r_eye - r_spot);
    bx_set_color (bx_blue ());
  }
  bx_draw_circle (window, x_spot - r_spot, y_spot - r_spot, 
                  2*r_spot, 2*r_spot, 1);
}

int main (void)
{
  bx_window window;
 
  unsigned w= 500, h= 500;

  int x_eye1= 1*w/3, y_eye1= h/2;
  int x_eye2= 2*w/3, y_eye2= h/2;
  unsigned r_eye= w/10, r_spot= 10;

  bx_init ();
  window= bx_create_window ("staring eyes", 100, 100, w, h);
  
  for (;;) {
    bx_mouse mouse= bx_read_mouse (window);
    int xm= bx_mouse_x (mouse);
    int ym= bx_mouse_y (mouse);
   
    bx_clear_canvas (window, bx_white ());
    draw_eye (window, x_eye1, y_eye1, r_eye, xm, ym, r_spot);
    draw_eye (window, x_eye2, y_eye2, r_eye, xm, ym, r_spot);

    bx_show_canvas (window, 20);
  }

  bx_loop ();
  return 0;
}
